#! /bin/sh
. "${srcdir=.}/init.sh"; path_prepend_ . ../src

# Test of gettext facilities in the JavaScript language.
# Assumes an fr_FR locale is installed.
# Assumes the following packages are installed: gjs.

cat <<\EOF > prog.js
const Format = imports.format;
const Gettext = imports.gettext;

String.prototype.format = Format.format;
const _ = Gettext.gettext;

Gettext.textdomain ("prog");
Gettext.bindtextdomain ("prog", "l-javascript");
print(_("'Your command, please?', asked the waiter."));
print(_("%s is replaced by %s.").format("FF", "EUR"));
EOF

: ${XGETTEXT=xgettext}
${XGETTEXT} -o l-javascript-prog.tmp --omit-header --no-location prog.js || exit 1
LC_ALL=C tr -d '\r' < l-javascript-prog.tmp > l-javascript-prog.pot || exit 1

cat <<EOF > l-javascript-prog.ok
msgid "'Your command, please?', asked the waiter."
msgstr ""

#, javascript-format
msgid "%s is replaced by %s."
msgstr ""
EOF

: ${DIFF=diff}
${DIFF} l-javascript-prog.ok l-javascript-prog.pot || exit 1

cat <<\EOF > l-javascript-fr.po
msgid ""
msgstr "Content-Type: text/plain; charset=ISO-8859-1\n"

msgid "'Your command, please?', asked the waiter."
msgstr "Votre commande, s'il vous plait, dit le garon."

# Reverse the arguments.
#, javascript-format
msgid "%s is replaced by %s."
msgstr "%s remplace %s."
EOF

: ${MSGMERGE=msgmerge}
${MSGMERGE} -q -o l-javascript-fr.po.tmp l-javascript-fr.po l-javascript-prog.pot || exit 1
LC_ALL=C tr -d '\r' < l-javascript-fr.po.tmp > l-javascript-fr.po.new || exit 1

: ${DIFF=diff}
${DIFF} l-javascript-fr.po l-javascript-fr.po.new || exit 1

test -d l-javascript || mkdir l-javascript
test -d l-javascript/fr || mkdir l-javascript/fr
test -d l-javascript/fr/LC_MESSAGES || mkdir l-javascript/fr/LC_MESSAGES

: ${MSGFMT=msgfmt}
${MSGFMT} -o l-javascript/fr/LC_MESSAGES/prog.mo l-javascript-fr.po

# Test for presence of gjs.
(gjs -h) >/dev/null 2>/dev/null \
  || { echo "Skipping test: gjs not found"; exit 77; }
(gjs -c imports.gettext) >/dev/null 2>/dev/null \
  || { echo "Skipping test: gjs gettext module not found"; exit 77; }
(gjs -c imports.format) >/dev/null 2>/dev/null \
  || { echo "Skipping test: gjs format module not found"; exit 77; }

# Test which of the fr_FR locales are installed.
: ${LOCALE_FR=fr_FR}
: ${LOCALE_FR_UTF8=fr_FR.UTF-8}
if test $LOCALE_FR != none; then
  LC_ALL=$LOCALE_FR ../testlocale
  case $? in
    0) ;;
    77) LOCALE_FR=none;;
    *) exit 1;;
  esac
fi
if test $LOCALE_FR_UTF8 != none; then
  LC_ALL=$LOCALE_FR_UTF8 ../testlocale
  case $? in
    0) ;;
    77) LOCALE_FR_UTF8=none;;
    *) exit 1;;
  esac
fi
if test $LOCALE_FR = none && test $LOCALE_FR_UTF8 = none; then
  if test -f /usr/bin/localedef; then
    echo "Skipping test: no french locale is installed"
  else
    echo "Skipping test: no french locale is supported"
  fi
  exit 77
fi

: ${DIFF=diff}
cat <<\EOF > l-javascript-prog.ok
Votre commande, s'il vous plait, dit le garon.
FF remplace EUR.
EOF
cat <<\EOF > l-javascript-prog.oku
«Votre commande, s'il vous plait», dit le garçon.
FF remplace EUR.
EOF

: ${LOCALE_FR=fr_FR}
: ${LOCALE_FR_UTF8=fr_FR.UTF-8}
if test $LOCALE_FR != none; then
  LANGUAGE= LC_ALL=$LOCALE_FR gjs prog.js > l-javascript-prog.out || exit 1
  ${DIFF} l-javascript-prog.ok l-javascript-prog.out || exit 1
fi
if test $LOCALE_FR_UTF8 != none; then
  LANGUAGE= LC_ALL=$LOCALE_FR_UTF8 gjs prog.js > l-javascript-prog.out || exit 1
  ${DIFF} -u l-javascript-prog.oku l-javascript-prog.out || exit 1
fi

exit 0
